/**
 *SSO App
 * Defined UNAS 3.0 SSO manager
 */
var BDRISPApp = BDRISPApp || {}; //Define App namespace, if you want.
/**
 *Constructor UNAS App
 */
BDRISPApp.App = function() {
  this.id = 'BDRisp';
  this.name = 'BDR ISP';
  this.version = '6.0.15';
  this.active = false;
  this.menuIcon = '/apps/bdrclientisp/images/logo.png?v=6.0.15&';
  this.shortcutIcon = '/apps/bdrclientisp/images/logo.png?v=6.0.15&';
  this.entryUrl = '/apps/bdrclientisp/bdr.html?v=6.0.15&';
  //this.entryHelpUrl = '/apps/sso/sso_help.html';
  var self = this;
  this.BDRISPAppWindow = function() { //create app window
    if (UNAS.CheckAppState('BDR ISP')) {
      return false;
    }
    self.window = new MUI.Window({
      id: 'BDRISPAppWindow',
      title: UNAS._('BDR ISP'),
      icon: '/apps/bdrclientisp/images/logo_small.png?v=6.0.15&',
      loadMethod: 'xhr',
      width: 886,
      height: 640,
      maximizable: false,
      resizable: true,
      scrollbars: false,
      resizeLimit: { 'x': [700, 1200], 'y': [500, 1500] },
      contentURL: '/apps/bdrclientisp/bdr.html?v=6.0.15&',
      require: {
        css: ['/apps/bdrclientisp/css/bdr.css?v=6.0.15']
      },
      onBeforeBuild: function() {
        UNAS.SetAppOpenedWindow("BDR ISP", 'BDRISPAppWindow');
      }
    });
  };
  this.BDRISPUninstall = function() {
    UNAS.RemoveDesktopShortcut('BDR ISP');
    UNAS.RemoveMenu('BDR ISP');
    UNAS.RemoveAppFromGroups('BDR ISP', 'ControlPanel');
    UNAS.RemoveAppFromGroups('BDR ISP', 'Help');
    UNAS.RemoveAppFromApps('BDR ISP');
  };
  new UNAS.Menu('UNAS_ControlPanel_Network_Menu',
  this.name, this.menuIcon, 'BDR ISP', '', this.BDRISPAppWindow);
  new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {
    'Type': 'Network',
    'Location': 4,
    "Icon": this.shortcutIcon,
    "Url": this.entryUrl
  }, {});
  var OnChangeLanguage = function(e) {
    UNAS.SetMenuTitle('BDR ISP', UNAS._('BDR ISP')); //translate menu
    //UNAS.SetShortcutTitle('SSO', UNAS._('User Account'));
    if (typeof self.window !== 'undefined') {
      UNAS.SetWindowTitle('BDRISPAppWindow', UNAS._('BDR ISP'));
    }
  };
  UNAS.LoadTranslation('/apps/bdrclientisp/languages/Translation?v=' + this.version, OnChangeLanguage);
  UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
  UNAS.CreateApp(this.name, this.shortcutIcon, this.BDRISPAppWindow, this.BDRISPUninstall);
};

new BDRISPApp.App();
