function bdrclient_settingload() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/wmi/index.php',
      data: JSON.stringify({
        "token": UToken,
        "cmd": 'bdrclientisp_settingload'
      }),
      type: "post",
      dataType: "json",
      contentType: 'application/json',
      timeout: 30000,
      success: function(res) {

        if (res.err == 0) {
          var info = res.results || {};
          var nebula = info.server || {};
          var lastbackup = info.lastbackup || {};
          var uploading = info.uploading || 0;
          var report = info.report || {};
          var dmpaths = info.dmpaths || [];
          var schedule = nebula.schedule || [];
          jQuery('#jv-ebs').prop('checked', info.active);
          jQuery('#jv-report').val(report.interval || 10);
          jQuery('#jv-cloudurl').val(nebula.host || '');
          jQuery('#jv-port-bdr').val(nebula.port || 22);
          jQuery('#jv-uid-bdr').val(nebula.uid || '');
          jQuery('#jv-pwd-bdr').val(nebula.pwd || '');
          if (schedule.length) {
            jQuery('#jv-timehost').empty();
            for (var i = 0; i < schedule.length; i++) {
              var sp = schedule[i];
              var tiemdom = bdrTemplateAppend('#jv-timehost', 'jvt-timeitem', 'jvt-timeitem-' + i);
              tiemdom.find('.timetx').text(addTimeZero(sp.hour) + ':' + addTimeZero(sp.minute)).attr('time', timeToTimestamp(sp.hour + ':' + sp.minute));
              tiemdom.find('.unas_icon_delete').on('click', function() {
                jQuery(this).parents('tr').remove();
              })
            }

            jQuery('#jv-timehost tr').sort(function(a, b) {
              var contentA = jQuery(a).find('.timetx').attr('time');
              var contentB = jQuery(b).find('.timetx').attr('time');
              return (contentA < contentB) ? -1 : (contentA > contentB) ? 1 : 0;
            }).appendTo('#jv-timehost');
          }

          jQuery('#jv-backup-bdr').val(nebula.interval || 60);
          if (uploading) {
            jQuery('#jv-lastbackuptime').html('Backing up...');
          } else {
            if (jQuery.isEmptyObject(lastbackup)) {
              jQuery('#jv-lastbackuptime').html('--');
              jQuery('#jv-uploadingresult').hide();
            } else {
              jQuery('#jv-uploadingresult').show();
              if (lastbackup.result == 9) {
                jQuery('#jv-uploadingstate').addClass('log-Completed');
              } else {
                jQuery('#jv-uploadingstate').addClass('log-Fail');
              }
              jQuery('#jv-lastbackuptime').html(lastbackup.time || '--');
            }

          }
          bdrTranslator('jv-lastbackuptime');
        }
        resolve(res);
        bdrclient_zfstorage(dmpaths);
      },
      complete: function(xml) {
        resolve(xml.responseJSON);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        reject(XMLHttpRequest);
      }
    })
  })
}

function bdrclient_settingsave() {
  var active = jQuery('#jv-ebs').prop('checked') ? 1 : 0;
  var interval = +jQuery('#jv-report').val();
  var url = jQuery('#jv-cloudurl').val();
  var port = +jQuery('#jv-port-bdr').val() || 22;
  var uid = jQuery('#jv-uid-bdr').val();
  var pwd = jQuery('#jv-pwd-bdr').val();
  var schedule = [];

  jQuery('#jv-timehost tr').each(function(i, e) {
    var time = jQuery(e).find('.timetx').text().split(':');
    schedule.push({
      hour: +time[0],
      minute: +time[1]
    })
  })

  var backup_interval = +jQuery('#jv-backup-bdr').val();
  var dmpaths = [];
  var dataset = jQuery('#jv-poolhost input[name=dataset]:checked');
  dataset.each(function(i, e) {
    dmpaths.push(jQuery(e).val());
  })

  jQuery('#jv-bdrpageloading').show();

  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'bdrclientisp_settingsave',
      params: {
        active: active,
        report: {
          interval: interval
        },
        server: {
          host: url,
          port: port,
          uid: uid,
          pwd: pwd,
          interval: backup_interval,
          schedule: schedule
        },
        dmpaths: dmpaths
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        bdrclient_settingload();
      } else {
        alert('Operation Failed');
      }
    },
    complete: function(xml) {
      jQuery('#jv-bdrpageloading').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function bdrclient_zfstorage(dmpaths) {
  dmpaths = dmpaths || [];
  if (!dmpaths.length) {
    dmpaths = ['bdr/data'];
  }
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'bdrclientisp_zfstorage'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      var i = 0
      jQuery('#jv-poolhost').empty();
      for (var v in info) {
        if (info.hasOwnProperty(v)) {
          var tp_ = info[v];
          var pooldom = bdrTemplateAppend('#jv-poolhost', 'jvt-pooldatasetitem', 'jvt-pooldatasetitem-' + i);
          pooldom.find('.poolname').text(v || '--');
          pooldom.find('input[name=pool]').on('click', function() {
            var len = jQuery('#jv-poolhost input[name=pool]').length;
            var len_ck = jQuery('#jv-poolhost input[name=pool]:checked').length;
            if (len == len_ck) {
              jQuery('#jv-pdallchk').prop('checked', true);
            } else {
              jQuery('#jv-pdallchk').prop('checked', false);
            }
            jQuery('#jv-poolhost input[name=pool]').not(this).prop('checked', false);
            var pnode_siblings = jQuery('#jv-poolhost input[name=pool]').not(this);

            var pnode = jQuery(this).closest('div.pool-datase-titem');
            if (jQuery(this).prop('checked')) {
              pnode.find('.datasetlist input').prop('checked', true);
            } else {
              pnode.find('.datasetlist input').prop('checked', false);
            }

            pnode_siblings.each(function(k, e) {
              var epnode = jQuery(e).closest('div.pool-datase-titem');
              epnode.find('.datasetlist input').prop('checked', false);
            })

          })

          var j = 0;
          for (var k in tp_) {
            if (tp_.hasOwnProperty(k)) {
              var td_ = tp_[k];
              var ddom = bdrTemplateAppend(pooldom.find('.datasetlist'), 'jvt-datasetitem', 'jvt-datasetitem-' + i + j)
              ddom.attr('style', "justify-content: space-between");
              ddom.find('.datasetname').text(k || '--');

              if (dmpaths.indexOf(td_.dmpath) != -1) {
                ddom.find('input[name=dataset]').prop('checked', true);
              }

              ddom.find('input[name=dataset]').val(td_.dmpath).on('click', function() {
                var pnode = jQuery(this).closest('div.pool-datase-titem');

                uppoolchecked(pnode);

                var pnode_siblings = jQuery('#jv-poolhost .pool-datase-titem').not(pnode);
                pnode_siblings.each(function(k, e) {
                  jQuery(e).find('input').prop('checked', false);
                })

              })

              ddom.find('.backup-details').data('d_info', td_).on('click', function() {
                var d_info = jQuery(this).data('d_info');
                backupdetails_dbr(d_info);
              })
            }
            j++;
          }
        }
        i++;
      }

      jQuery('#jv-poolhost').children().each(function(i, e) {
        uppoolchecked(jQuery(e));
      });

      if (jQuery('#jv-poolhost').children().length) {
        jQuery('#jv-pdtop').show();
      }


    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

//灾难恢复
function bdrclientisp_restore() {
  var url = jQuery('#jv-cloudurl-dr').val();
  var port = jQuery('#jv-port-dr').val();
  var uid = jQuery('#jv-uid-bdr-dr').val();
  var pwd = jQuery('#jv-pwd-bdr-dr').val();

  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'bdrclientisp_restore',
      params: {
        server: url,
        port: port,
        userid: uid,
        passwd: pwd
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        bdrclient_settingload();
        sanav('task', '#jv-tasknav');
      } else {
        if (bdrisp_errmsg[res.err]) {
          alert(bdrisp_errmsg[res.err]);
        } else {
          alert('##$@bdr@$##Restore Fail##$@bdr@$##');
        }

      }
    },
    complete: function(xml) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}
//

// tasks
var tasktimeid = null;

function bdrclientisp_task_alload() {
  clearTimeout(tasktimeid);
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'bdrclientisp_task_alload'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      var records = info.records || [];
      // records = [{
      //   action : 2,
      //   rate : 0,
      //   index: 5,
      //   dmpath: "bdr/data",
      //   speed : '0kb/s',
      //   step: 1
      // }]
      jQuery('#jv-tasktypehost').empty();
      var step = {
        0: "##$@bdr@$##Waiting##$@bdr@$##",
        1: "##$@bdr@$##In Progress##$@bdr@$##"
      }
      var action = {
        2: {
          des: "##$@bdr@$##Cloud Backup##$@bdr@$##",
        },
        3: {
          des: "##$@bdr@$##Disaster Recovery##$@bdr@$##",
        }
      }
      if (records.length) {
        for (var i = 0; i < records.length; i++) {
          var t_p = records[i];
          if (!t_p.removed) {
            var taskdom = bdrTemplateAppend('#jv-tasktypehost', 'jvt-taskitem', 'jvt-taskitem-' + i);
            taskdom.attr('style', '');
            taskdom.find('.taskname').text(t_p.dmpath);
            if (t_p.step) {
              taskdom.find('.bdrtasktype').addClass('taskaction-' + t_p.action);
            } else {
              taskdom.find('.bdrtasktype').addClass('taskawaitingction-' + t_p.action);
            }
            taskdom.find('.taskstate').addClass('taskstate-' + t_p.step).text(step[t_p.step]);
            taskdom.find('.tasktype').text(action[t_p.action].des);
            taskdom.find('.taskspeed').text(t_p.speed || '0kb/s');
            var rate = t_p.rate > 100 ? 100 : t_p.rate;
            taskdom.find('.bar-w').css('width', (rate || 0) + '%');
            taskdom.find('.percent_txt').text((rate || 0) + '%');
            var totalsize = UNAS.getReadableSizeString(t_p.totalsize || 0);
            var currsize = UNAS.getReadableSizeString(t_p.currsize || 0);

            taskdom.find('.totalsize').text(totalsize);
            taskdom.find('.currsize').text(currsize);

            taskdom.find('.canceltaskbtn').data('taskinfo', t_p).on('click', function() {
              var taskinfo = jQuery(this).data('taskinfo');
              bdr_alertWindowFn({
                tips: UNAS._('##$@bdr@$##Are you sure to cancel the current task?##$@bdr@$##')
              }, function() {
                bdrclientisp_task_cancel(taskinfo.index);
              });
            });
          }
        }
      } else {
        jQuery('#jv-tasktypehost').html('<div class="notask">No tasks at the moment</div>');
      }

      bdrTranslator('jv-tasktypehost');
    },
    complete: function(xml) {

      if (jQuery('#jv-task').is(':visible')) {
        tasktimeid = setTimeout(function() {
          bdrclientisp_task_alload();
        }, 3000);
      } else {
        clearTimeout(tasktimeid);
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function bdrclientisp_task_cancel(index) {
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'bdrclientisp_task_cancel',
      params: {
        index: index
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        bdrclientisp_task_alload()
      } else {
        alert('Operation Failed');
      }
    },
    complete: function(xml) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}
//
// log
function bdrclientisp_log_alload() {
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'bdrclientisp_log_alload'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      var records = info.records || [];
      jQuery('#jv-loghost').empty();
      var state = {
        3: '##$@bdr@$##Fail##$@bdr@$##',
        8: '##$@bdr@$##Cancel##$@bdr@$##',
        9: '##$@bdr@$##Completed##$@bdr@$##'
      }
      var action = {
        1: '##$@bdr@$##Local Backup##$@bdr@$##',
        2: '##$@bdr@$##Cloud Backup##$@bdr@$##',
        3: '##$@bdr@$##Disaster Recovery##$@bdr@$##'
      }
      for (var i = 0; i < records.length; i++) {
        var t_p = records[i];
        var logdom = bdrTemplateAppend('#jv-loghost', 'jvt-logitem', 'jvt-logitem-' + i);
        logdom.find('.logname').text(action[t_p.action]);
        logdom.find('.logtime').text(t_p.eventtime);
        logdom.find('.logstate').text(state[t_p.state]).addClass('log-state-' + t_p.state);
        logdom.find('input[name="logitem"]').val(t_p.ipaddr).on('click', function() {
          var len = jQuery('#jv-loghost input[name=logitem]').length;
          var len_ck = jQuery('#jv-loghost input[name=logitem]:checked').length;
          if (len == len_ck) {
            jQuery('#jv-selalllog').prop('checked', true);
          } else {
            jQuery('#jv-selalllog').prop('checked', false);
          }
        });
      }

      bdrTranslator('jv-loghost');
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

//

function uppoolchecked(pnode) {

  var d_len = pnode.find('input[name=dataset]').length;
  var d_len_ck = pnode.find('input[name=dataset]:checked').length;
  if (d_len == d_len_ck) {
    pnode.find('input[name=pool]').prop('checked', true);
  } else {
    pnode.find('input[name=pool]').prop('checked', false);
  }
  var p_len = jQuery('#jv-poolhost input[name=pool]').length;
  var p_len_ck = jQuery('#jv-poolhost input[name=pool]:checked').length;

  if (p_len == p_len_ck) {
    jQuery('#jv-pdallchk').prop('checked', true);
  } else {
    jQuery('#jv-pdallchk').prop('checked', false);
  }

}

function upbdrapplybtn() {
  var report = +jQuery('#jv-report').val() || 0;
  var backuptime = +jQuery('#jv-backup-bdr').val() || 0;

  var url = jQuery('#jv-cloudurl').val();

  if (report && report >= 1) {
    jQuery('#jv-bdrapplybtn').attr('class', 'unas_button');
    if (url) {
      if (backuptime >= 5) {
        jQuery('#jv-bdrapplybtn').attr('class', 'unas_button');
      } else {
        jQuery('#jv-bdrapplybtn').attr('class', 'unas_button_disabled');
      }
    }
  } else {
    jQuery('#jv-bdrapplybtn').attr('class', 'unas_button_disabled');
  }
}

(function() {
  var strHour = '';
  var strMinute = '';
  for (var i = 0; i < 24; i++) {
    strHour += '<option value=\"' + i + '\">' + i + '</option>';
  }
  for (var i = 0; i < 60; i++) {
    strMinute += '<option value=\"' + i + '\">' + i + '</option>';
  }
  jQuery('#jv-backup-hour').html(strHour);
  jQuery('#jv-backup-minute').html(strMinute);

  bdrclient_settingload();


  jQuery('#jv-pdallchk').on('click', function() {
    var allpool = jQuery('#jv-poolhost input[type="checkbox"]');
    if (this.checked) {
      allpool.prop('checked', true);
    } else {
      allpool.prop('checked', false);
    }
  })

  jQuery('#jv-selalllog').on('click', function() {
    var allpool = jQuery('#jv-loghost input[name="logitem"]');
    if (this.checked) {
      allpool.prop('checked', true);
    } else {
      allpool.prop('checked', false);
    }
  })

  jQuery("#jv-poollist").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  jQuery('#jv-report').bind('input propertychange', function(e) {
    var v = +jQuery(this).val() || 0;
    if (v < 1) {
      jQuery(this).attr('class', 'unas_input_error');
    } else {
      jQuery(this).attr('class', 'unas_input');
    }
    upbdrapplybtn();
  });

  jQuery('#jv-backup-bdr').bind('input propertychange', function(e) {
    var v = +jQuery(this).val() || 0;
    if (v < 5) {
      jQuery(this).attr('class', 'unas_input_error');
    } else {
      jQuery(this).attr('class', 'unas_input');
    }
    upbdrapplybtn();
  });

  jQuery('#jv-cloudurl').bind('input propertychange', function(e) {
    upbdrapplybtn();
  });

  jQuery('#jv-dr input').bind('input propertychange', function(e) {
    var url = jQuery('#jv-cloudurl-dr').val();
    var port = jQuery('#jv-port-dr').val();
    var uid = jQuery('#jv-uid-bdr-dr').val();
    var pwd = jQuery('#jv-pwd-bdr-dr').val();
    var ck = jQuery('#jv-confirm-dr').prop('checked');
    if (ck && url && port && uid && pwd) {
      jQuery('#jv-drbtn').attr('class', 'unas_button');
    } else {
      jQuery('#jv-drbtn').attr('class', 'unas_button_disabled');
    }
  });

})();
