var bdrisp_errmsg = {
  9886 : 'Operation failed, possibly due to incorrect cloud machine account or password',
  9987 : 'The Pool on the local disk does not exist and needs to be created first',
  9992 : 'The recovery task is currently in progress, please try again later',
  9993 : 'The volume on the local disk already exists and cannot be overwritten for recovery. Please delete it first',
  9994 : 'There is no backed up data on the cloud machine, which cannot be restored'
}

function backupdetails_dbr(data) {
  new MUI.Modal({
    id: 'jv-backupdetailsWindow',
    title: UNAS._('Backup details'),
    modal: true,
    width: 900,
    height: 460,
    modalOverlayClose: false,
    data: data,
    contentURL: '/apps/bdrclientisp/backup_details.html?v=6.0.15'
  });
}

function bdr_alertWindowFn(data, fn) {
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._(data.title || 'Tips'),
    modal: true,
    modalOverlayClose: false,
    width: 400,
    height: 160,
    data: data,
    contentURL: '/apps/bdrclientisp/confirmAlert.html?=v=6.0.15&'
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function cloudHostSnapshot() {
  new MUI.Modal({
    id: 'jv-cloudhostsnapshotWindow',
    title: UNAS._('Cloud host snapshot'),
    modal: true,
    width: 900,
    height: 470,
    modalOverlayClose: false,
    contentURL: '/apps/bdrclientisp/snapshot.html?v=6.0.15'
  });
}

function sanav(t, et) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  if (et) {
    that = jQuery(et);
  }
  that.attr('class', 'unas_tab_sel').siblings().attr('class', 'unas_tab');
  jQuery('#jv-' + t).show().siblings().hide();
  if (t == 'pd' || t == 'routine') {
    jQuery('#jv-bdrapplybtn-footer').show();
    jQuery('#jv-drbtn-footer').hide();
    bdrclient_settingload();
  } else if (t == 'dr') {
    jQuery('#jv-bdrapplybtn-footer').hide();
    jQuery('#jv-drbtn-footer').show();
    jQuery('#jv-cloudurl-dr').val(jQuery('#jv-cloudurl').val());
    jQuery('#jv-port-dr').val(jQuery('#jv-port-bdr').val());
    jQuery('#jv-uid-bdr-dr').val(jQuery('#jv-uid-bdr').val());
    jQuery('#jv-pwd-bdr-dr').val(jQuery('#jv-pwd-bdr').val());
  } else {
    jQuery('#jv-bdrapplybtn-footer').hide();
    jQuery('#jv-drbtn-footer').hide();
  }

  if (t == 'task') {
    bdrclientisp_task_alload();
  } else if (t == 'log') {
    bdrclientisp_log_alload();
  } else {

  }

}

function addUploadTime() {
  var i = new Date().getTime();
  var h = jQuery('#jv-backup-hour').val();
  var m = jQuery('#jv-backup-minute').val();

  jQuery('#jv-timehost tr').each(function(i, e) {
    var content = jQuery(e).find('.timetx').attr('time');
    var cur = timeToTimestamp(h + ':' + m);
    if (content == cur) {
      jQuery(e).remove();
    }
  })

  var tiemdom = bdrTemplateAppend('#jv-timehost', 'jvt-timeitem', 'jvt-timeitem-' + i);

  tiemdom.find('.timetx').text(addTimeZero(h) + ':' + addTimeZero(m)).attr('time', timeToTimestamp(h + ':' + m));
  tiemdom.find('.unas_icon_delete').on('click', function() {
    jQuery(this).parents('tr').remove();
  })

  jQuery('#jv-timehost tr').sort(function(a, b) {
    var contentA = jQuery(a).find('.timetx').attr('time');
    var contentB = jQuery(b).find('.timetx').attr('time');
    return (contentA < contentB) ? -1 : (contentA > contentB) ? 1 : 0;
  }).appendTo('#jv-timehost');

}

function addTimeZero(num) {
  return num >= 10 ? num : '0' + num;
}

function timeToTimestamp(time) {
  var [hours, minutes] = time.split(':').map(Number);
  var date = new Date();
  date.setHours(hours, minutes, 0, 0);
  return date.getTime();
}

function showdatasetlist() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  var pnode = that.closest('div.pool-datase-titem');
  that.toggleClass('pool-o');
  pnode.find('.datasetlist').slideToggle();
}

function checkpwd() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);

  if (that.hasClass('checkpwd_close')) {
    that.attr('class', 'checkpwd_open');
    that.siblings('input').attr('type', 'password');
  } else {
    that.attr('class', 'checkpwd_close');
    that.siblings('input').attr('type', 'text');
  }

}

function bdrTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
};

(function() {

  var OnChangeLanguage_bdr = null;
  var pageTranslators_bdr = [];
  OnChangeLanguage_bdr = function(e) {
    for (var i = 0; i < pageTranslators_bdr.length; i++) {
      var node = pageTranslators_bdr[i].node;
      var p = pageTranslators_bdr[i].translateProperty;
      node[p] = window.top.UNAS._(pageTranslators_bdr[i].originalText);
    }

    function bdrTranslator(id) {
      let rt_c = document.getElementById(id);
      if (!rt_c) {
        return;
      }
      var tmp_pageTranslators = window.top.UNAS.CreateNodesTranslators(rt_c);
      pageTranslators_bdr = pageTranslators_bdr.concat(tmp_pageTranslators);
      OnChangeLanguage_bdr();
    }
    window.bdrTranslator = bdrTranslator;
  };
  OnChangeLanguage_bdr();
  window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage_bdr);
  window.addEventListener("unload", function(e) {
    window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage_bdr);
  }, false);

  jQuery('.cloudnav').on('click', function() {
    var i = jQuery('.cloudnav').index(this);
    jQuery(this).addClass('cur-nav').siblings().removeClass('cur-nav');
    jQuery(this).removeClass('sel-nav');
    jQuery(this).siblings().addClass('sel-nav');
    jQuery('.jvc-cloudtype').eq(i).show().siblings('.jvc-cloudtype').hide();
  })


  jQuery("#jv-timehostcontent").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery("#jv-loghostcontent").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  jQuery("#jv-tasktype").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  jQuery("#id-bdrcontent").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });



})();
